//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 8

//
//
//
//
//

extern string _          = "Parameters";
extern int    DemaPeriod = 21;
extern int    DemaPrice  = PRICE_CLOSE;
extern int    DemaMode   = MODE_EMA;  
extern int    EnvPer     = 40;
extern int    EnvMode    = MODE_LWMA;
extern int    LineStyle  = STYLE_SOLID;
extern int    LineWidth  = 2;
extern int    HistoStyle = STYLE_DOT;
extern int    HistoWidth = 1;
extern color  ColorUp    = DeepSkyBlue;
extern color  ColorDown  = PaleVioletRed;

//
//
//
//
//

double histoUp[];
double histoDn[];
double upperEn[];
double upperEnda[];
double upperEndb[];
double lowerEn[];
double lowerEnda[];
double lowerEndb[];

string indicatorFileName;
bool   calculateDema;
bool   initialized=false;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   calculateDema     = (_=="calculateDema");
   indicatorFileName = WindowExpertName();
      SetIndexBuffer(0, histoUp);
      SetIndexBuffer(1, histoDn);
      SetIndexBuffer(2, upperEn); 
      SetIndexBuffer(3, upperEnda); 
      SetIndexBuffer(4, upperEndb); 
      SetIndexBuffer(5, lowerEn); 
      SetIndexBuffer(6, lowerEnda); 
      SetIndexBuffer(7, lowerEndb); 
   return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _dema  0
#define _trend 1

//
//
//
//
//

int start()
{ 
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           
           //
           //
           //
           //
           //
           
              if (calculateDema)
              {
                  for(i=limit; i>=0; i--) histoDn[i] = iMA(NULL,0,DemaPeriod,0,DemaMode,DemaPrice,i);
                  for(i=limit; i>=0; i--) histoUp[i] = iMAOnArray(histoDn,0,DemaPeriod,0,DemaMode,i);
                  return(0);
              }
           
           //
           //
           //
           //
           //
           
           static bool buffersInitialized=false;
              if (!buffersInitialized)
              {
                  buffersInitialized = true;
                     SetIndexStyle (0, DRAW_HISTOGRAM, HistoStyle, HistoWidth, ColorUp);
                     SetIndexStyle (1, DRAW_HISTOGRAM, HistoStyle, HistoWidth, ColorDown);
                     SetIndexStyle (2, DRAW_LINE,      LineStyle,  LineWidth , ColorUp);
                     SetIndexStyle (3, DRAW_LINE,      LineStyle,  LineWidth , ColorDown);
                     SetIndexStyle (4, DRAW_LINE,      LineStyle,  LineWidth , ColorDown);
                     SetIndexStyle (5, DRAW_LINE,      LineStyle,  LineWidth , ColorUp);
                     SetIndexStyle (6, DRAW_LINE,      LineStyle,  LineWidth , ColorDown);
                     SetIndexStyle (7, DRAW_LINE,      LineStyle,  LineWidth , ColorDown);
              }

   //
   //
   //
   //
   //

   if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
   if (work[Bars-limit-1][_trend]==-1) { CleanPoint(limit,upperEnda,upperEndb); CleanPoint(limit,lowerEnda,lowerEndb); }

      //
      //
      //
      //
      //
      
      for(i=limit, r=Bars-i-1; i>=0; i--, r++)
      {
         work[r][_dema]  = iCustom(NULL,0,indicatorFileName,"calculateDema",DemaPeriod,DemaPrice,DemaMode,0,i);
         work[r][_trend] = work[r-1][_trend];
      
            if (work[r][_dema]>work[r-1][_dema]) work[r][_trend] =  1;
            if (work[r][_dema]<work[r-1][_dema]) work[r][_trend] = -1;
         
            //
            //
            //
            //
            //
         
            upperEnda[i] = EMPTY_VALUE;
            upperEndb[i] = EMPTY_VALUE;
            lowerEnda[i] = EMPTY_VALUE;
            lowerEndb[i] = EMPTY_VALUE;
            upperEn[i]   = iMA(NULL,0,EnvPer,0,EnvMode,PRICE_HIGH,i);
            lowerEn[i]   = iMA(NULL,0,EnvPer,0,EnvMode,PRICE_LOW ,i);
            if (work[r][_trend] == -1)
            {
               histoUp[i] = lowerEn[i];
               histoDn[i] = upperEn[i];
               PlotPoint(i,lowerEnda,lowerEndb,lowerEn);
               PlotPoint(i,upperEnda,upperEndb,upperEn);
            }
            else
            {
               histoDn[i] = lowerEn[i];
               histoUp[i] = upperEn[i];
            }
      }
      
   //
   //
   //
   //
   //
         
   return(0);
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}